Index: src/Fl_Window.cxx
===================================================================
--- src/Fl_Window.cxx	(revision 9873)
+++ src/Fl_Window.cxx	(working copy)
@@ -107,19 +107,19 @@
 }
 
 /**
-  Finds the x/y offset of the current window relative to the top-level window.
+  Finds the x/y offset of the current widget relative to the top-level window.
   \param[out] xoff,yoff Returns the x/y offset
-  \returns the top-level window
+  \returns the top-level window (or NULL for a widget that's not in any window)
 */
 Fl_Window* Fl_Widget::top_window_offset(int& xoff, int& yoff) const {
   xoff = yoff = 0;
-  const Fl_Window *win = (const Fl_Window*)this;
+  Fl_Widget *win = (Fl_Widget*)this;
   while (win && win->window()) {
     xoff += win->x();			// accumulate offsets
     yoff += win->y();
     win = win->window();		// walk up window hierarchy
   }
-  return (Fl_Window*)win;
+  return win->as_window();
 }
 
 /** Gets the x position of the window on the screen */
